package com.fluentcommerce.dto;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonPOJOBuilder;
import java.util.List;
import lombok.Builder;
import lombok.Value;
import org.apache.commons.lang3.StringUtils;

@Value
@Builder(builderClassName = "Builder",
    toBuilder = true)
@JsonDeserialize(builder = SettingListEntity.Builder.class)
@JsonIgnoreProperties(ignoreUnknown = true)
public class SettingListEntity {

    String label;
    String value;

    @JsonPOJOBuilder(withPrefix = "")
    public static final class Builder {

    }

    public boolean isCurrentValue(String value) {
        return StringUtils.equalsIgnoreCase(this.value, value);
    }

    public static String findLabelByValue(List<SettingListEntity> entities, String value) {
        return entities.stream().filter(entity -> entity.isCurrentValue(value)).findFirst()
            .orElse(SettingListEntity.builder().label(value).build()).getLabel();
    }
}
