package com.fluentretail.se.plugins.util.v2;

import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.JavaType;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.type.CollectionType;
import com.fluentretail.rubix.v2.context.Context;
import java.util.ArrayList;
import java.util.List;

public class ContextUtils {

    public static <T> T getConvertedValue(Context context, ObjectMapper objectMapper, String attributeName, TypeReference<T> typeReference) {
        T convertedValue = objectMapper.convertValue(
            context.getEvent().getAttributes().get(attributeName), typeReference
        );
        return convertedValue;
    }

    public static <T> T getAttribute(Context context, ObjectMapper objectMapper, String attributeName, Class clazz) {
        JavaType type = objectMapper.getTypeFactory().constructType(clazz);
        T convertedValue = objectMapper.convertValue(
            context.getEvent().getAttributes().get(attributeName),
            type
        );
        return convertedValue;
    }

    public static <T> List<T> getAttributeList(Context context, ObjectMapper objectMapper, String attributeName, Class clazz) {
        CollectionType listType = objectMapper.getTypeFactory().constructCollectionType(ArrayList.class, clazz);
        List<T> convertedValue = objectMapper.convertValue(
            context.getEvent().getAttributes().get(attributeName),
            listType
        );
        return convertedValue;
    }
}
